#***********************************************************************
#*  sminer - Synchronise a database with Slurm sacct records
#***********************************************************************
#* Copyright (C) 2021 Greg Wickham <greg@wickham.me>
#*
#* This file is part of sminer.
#*
#*  sminer is free software: you can redistribute it and/or modify
#*  it under the terms of the GNU General Public License as published by
#*  the Free Software Foundation, either version 3 of the License, or
#*  (at your option) any later version.
#*
#*   sminer is distributed in the hope that it will be useful,
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#*   GNU General Public License for more details.
#*
#*   You should have received a copy of the GNU General Public License
#*   along with sminer.  If not, see <https://www.gnu.org/licenses/>.
#***********************************************************************

PACKAGE_NAME        :=  sminer
PACKAGE_VERSION     :=  1.3
PACKAGE_COPYRIGHT   :=  (C) 2021 <greg@wickham.me>
PACKAGE_LICENSE     :=  GPL-3.0-or-later
PACKAGE_RELEASE     :=  11
PACKAGE_AUTHOR      :=  Greg Wickham <greg@wickham.me>
PACKAGE_GIT         :=  https://gitlab.com/greg.wickham/sminer

OBJS        :=  main.o sacct.o mylib.o timer.o \
				data.o data-tres.o data-nodelist.o data-state.o \
				data-int.o data-elapsed.o data-elapsed-raw.o data-string.o \
				data-jobid.o data-bytes.o data-node.o \
				data-datetime.o postgres.o node.o query.o \
				db-table.o db-field.o db-row.o \
				stats.o config.o slurm.o parser.o rpn.o args.o \
				app.o

PROGRAM := $(PACKAGE_NAME)

SOURCEDIR=$(shell rpmbuild -E "%{_sourcedir}")
BASEDIR=$(shell basename `pwd`)
TARBALL=${PACKAGE_NAME}-${PACKAGE_VERSION}.tar

DEFINES := -g -Wall -std=c++11

DEPENDS := Makefile

PROGRAM := sminer

PKGCONFIG := /usr/bin/pkg-config

PKG_LIST := yaml-cpp sigc++-2.0 jsoncpp

LIBS := -lpq

ifdef PKG_LIST
PKG_INCLUDES	:=	`$(PKGCONFIG) --cflags $(PKG_LIST)`
PKG_LIBS		:=	`$(PKGCONFIG) --libs $(PKG_LIST)`
endif

all: $(PROGRAM)

%.o: %.c $(DEPENDS) Makefile
	@( if [[ ! -d dependencies ]]; then \
	echo " MKDIR depdencies"; \
	mkdir -p dependencies ;\
	fi )
	@echo "   G++ $<"
	@g++ $(DEFINES) $(PKG_INCLUDES) $(INCLUDES) -c $< -MD -MF dependencies/$<.dep

%.o: %.cpp $(DEPENDS) Makefile
	@( if [[ ! -d dependencies ]]; then \
	echo " MKDIR depdencies"; \
	mkdir -p dependencies ;\
	fi )
	@echo "   G++ $<"
	g++ $(DEFINES) $(PKG_INCLUDES) $(INCLUDES) -c $< -MD -MF dependencies/$<.dep

$(PROGRAM): $(OBJS)
	@echo "CREATE build-definitions.c (VERSION=$(PACKAGE_VERSION) RELEASE=$(PACKAGE_RELEASE))"
	@( \
		echo "/* AUTOGENERATED DURING COMPILATION */" ; \
		echo "const char *PROG_NAME = \"$(PACKAGE_NAME)\";" ; \
		echo "const char *PROG_AUTHOR = \"$(PACKAGE_AUTHOR)\";" ; \
		echo "const char *PROG_VERSION = \"$(PACKAGE_VERSION)-$(PACKAGE_RELEASE)\";"; \
		echo "const char *PROG_BUILD = \"$(shell date )\";" ; \
		echo "const char *PROG_LICENSE = \"$(PACKAGE_LICENSE)\";" ; \
		echo "const char *PROG_COPYRIGHT = \"$(PACKAGE_COPYRIGHT)\";" ; \
		echo "const char *PROG_GIT = \"$(PACKAGE_GIT)\";" ; \
		echo "/* END OF FILE */" \
	) > build-definitions.c
	@echo "   G++ build-definitions.c"
	@g++ $(DEFINES) $(PKG_INCLUDES) $(INCLUDES) -c build-definitions.c
	@echo "  LINK $@"
	@g++ $(DEFINES) $(INCLUDES) $(LIBS) -o $(PROGRAM) $(OBJS) build-definitions.o \
		$(LIBDIR) $(PKG_LIBS)

install: ${PROGRAM}
	@echo "INSTALL ${prefix}"
	@mkdir -vp ${DESTDIR}/usr/share/${PROGRAM}
	@install -vm 0755 ${PROGRAM} ${DESTDIR}/usr/bin
	@install -vm 0755 etc/sminer.yaml ${DESTDIR}/etc
	@install -vm 0755 docs/schema.sql ${DESTDIR}/usr/share/${PROGRAM}
	@install -vm 0755 README.md ${DESTDIR}/usr/share/${PROGRAM}

.PHONY: rpm

rpm: clean
	@echo " TAR -cvf ${SOURCEDIR}/${TARBALL}.bz2 ..."
	@tar -C .. -cjf ${SOURCEDIR}/${TARBALL}.bz2 \
		--transform "s/^${BASEDIR}/${PACKAGE_NAME}-${PACKAGE_VERSION}/" \
		--exclude \*.sh \
		--exclude .\*.swp \
		--exclude .nfs\* \
		--exclude .git\* \
		--exclude \*.o \
		--exclude gnuplot \
		--exclude \*.py \
		--exclude tmp ${BASEDIR}
	@echo " EXEC rpmbuild . . VERSION=${PACKAGE_VERSION} RELEASE=${PACKAGE_RELEASE}"
	rpmbuild --clean \
		--define "VERSION ${PACKAGE_VERSION}" \
		--define "RELEASE ${PACKAGE_RELEASE}" \
		-tb ${SOURCEDIR}/${TARBALL}.bz2

.PHONY: mock

ARCH := "centos+epel-7-x86_64"

mock: clean
	@echo " TAR -cvf ${SOURCEDIR}/${TARBALL}.bz2 ..."
	@tar -C .. -cjf ${SOURCEDIR}/${TARBALL}.bz2 \
		--transform "s/^${BASEDIR}/${PACKAGE_NAME}-${PACKAGE_VERSION}/" \
		--exclude \*.sh \
		--exclude .\*.swp \
		--exclude .nfs\* \
		--exclude .git\* \
		--exclude \*.o \
		--exclude gnuplot \
		--exclude \*.py \
		--exclude tmp ${BASEDIR}
	@echo "EXEC mock -r ${ARCH} --init"
	@mock -r ${ARCH} --init
	@echo "EXEC mock -r ${ARCH}+epel-7-x86_64 . . VERSION=${PACKAGE_VERSION} RELEASE=${PACKAGE_RELEASE}"
	mock -r ${ARCH} \
		--clean \
		--buildsrpm \
		--spec sminer.spec \
		--sources ${SOURCEDIR}/${TARBALL}.bz2 \
		--resultdir=SRPMS \
		--define "VERSION ${PACKAGE_VERSION}" \
		--define "RELEASE ${PACKAGE_RELEASE}"
	mock -r ${ARCH} \
		--clean \
		--rebuild SRPMS/${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}.el7.src.rpm \
		--resultdir=RPMS

.PHONY: clean

clean:
	@echo "  RM $(PROGRAM) *.o"
	@rm -f $(PROGRAM) $(OBJS) build-definitions.o
	@echo "  RM dependencies"
	@rm -rf dependencies

-include $(wildcard dependencies/*.dep)

